#include <stdio.h>
#include <unistd.h>

#include <iostream.h>

#include "TRIPUpdateMsg.hxx"
#include "IncomingPolicyAgent.hxx"
#include "LSSessionManager.hxx"
#include "NetworkAddress.h"
#include "TRIPItadKey.hxx"
#include "TRIPId.hxx"
#include "TRIBAgent.hxx"
#include "TRIPDef.hxx"
#include "cpLog.h"
#include "TimeTracker.hxx"
#include "Aggregator.hxx"

main()
{
    //TESTING ONLY
    //Create the UPdate Message
    TimeTracker t(cerr);
    int NUM_MSG = 50;
    int NUM_RTES = 2000;
    Sptr <TRIPUpdateMsg> uMsg[50];
    Sptr<TRIPWithdrawnRoute> route1 = new TRIPWithdrawnRoute();
    Sptr<TRIPReachableRoute> route2 = new TRIPReachableRoute();

    int d1=0, d2=0, d3=0, d4=0, d5 = 0;;
    string sStr;

    for (int j = 0; j < NUM_MSG; j++)
    {
        uMsg[j] = new TRIPUpdateMsg();
        for(int i = j*NUM_RTES ; i < (j+1)*NUM_RTES; i++)
        {
            char buf[256];
            sprintf(buf, "%d%d%d%d%d", d1, d2, d3, d4, d5);
            TRIPRoutes tRoute6(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData(buf));
            if ((j == 0) && (i == 0))
            {
                cerr << "first rte " << d1 << d2 << d3 << d4 << d5  << endl;
            }
            if ((j == (NUM_MSG - 1)) && (i == (NUM_MSG*NUM_RTES) - 1))
            {
                cerr << "last rte " << d1 << d2 << d3 << d4 << d5  << endl;
            }
            *route2 << tRoute6;
            d5++;
            if(d5 >= 10) { d5 = 0; d4++; };
            if(d4 >= 10) { d5 = 0; d4 = 0; d3++; };
            if(d3 >= 10) { d4 = 0; d3 = 0; d2++; };
            if(d2 >= 10) { d4 = 0; d3 = 0; d2 = 0; d1++; };
            if(d1 >= 10) { break; };
            if(i == 50000) sStr = buf;
        }

        uMsg[j]->addWithdrawnRoute(route1);
        uMsg[j]->addReachableRoute(route2);

        TRIPItadPathSegment seg1(TRIP_SEG_AP_SET, 1224);
        Sptr<TRIPAdvertisePath> aPath = new TRIPAdvertisePath();
        *aPath << seg1;

        TRIPItadPathSegment seg2(TRIP_SEG_AP_SET, 1224);
        Sptr<TRIPRoutedPath> aPath2 = new TRIPRoutedPath();
        *aPath2 << seg2;

        uMsg[j]->addAttribute(aPath);
        uMsg[j]->addAttribute(aPath2);

        Sptr<TRIPNextHopServer> nServer = new TRIPNextHopServer(1223,
                                                      TRIPData("ganesh:5060"));
        uMsg[j]->addAttribute(nServer);
        route2 = new TRIPReachableRoute();
    }

    LSSessionManager::instance(1234);
    u_int16_t itad = 10;
    char buf[256];
    strcpy(buf, "localhost");
    gethostname(buf, 256);
    NetworkAddress na(buf);
    Sptr <TRIPItadKey > itadkey = new TRIPItadKey(itad, TRIPId(na.getIp4Address ()));
    TRIBAgent& tribagent = TRIBAgent::instance();
    tribagent.createAdjTribIn(*itadkey, TC_EXTERNAL);

    Sptr <TRIPWorkSet> workSet = new TRIPWorkSet();
    Sptr <TRIPWorkSet> workSet2 = new TRIPWorkSet();
    TRIPProtoKey pKey(TRIP_APP_PROTO_SIP, TRIP_ADDR_POTS);
    //cpLogSetPriority(7);
    try
    {
        IncomingPolicyAgent& ipa = IncomingPolicyAgent::instance();
        cerr << "Inserting all routes... " << endl;
        t.startTime();
        for (int j=0; j < NUM_MSG; j++)
        {
            ipa.process(uMsg[j], *itadkey, workSet);
            workSet = new TRIPWorkSet();
        }
        t.endTime();
        Sptr<TRIPTrieCache> cache = tribagent.getTribIn(*itadkey);
        Sptr<TRIPRouteSet> adjTribInRouteSet = cache->getRouteSet(pKey);
        cerr << "Size of Trib In = " << adjTribInRouteSet->size() << endl;
    }
    catch(VException& e)
    {
        cerr << "Caught exception:" << e.getDescription().c_str() << endl;
    }
    cerr << "Processing Complete" << endl;
    Sptr<TRIPTrieCache> cache = tribagent.getTribIn(*itadkey);
    Sptr<TRIPRouteSet> adjTribInRouteSet = cache->getRouteSet(pKey);
    cerr << "Size of Trib In = " << adjTribInRouteSet->size() << " " << endl;

    // set AGGR_BIT so that routes are processed by Aggregation
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet->begin();itr != adjTribInRouteSet->end(); itr++)
    {
        (*itr)->setChanged(T_AGGR_BIT);
    }

    //cpLogSetPriority(7);
    cerr << "Begin aggregation.... " << endl;
    Sptr <Aggregator> aggAgt = new Aggregator();
    t.startTime();
    aggAgt->process(*cache);
    t.endTime();

    Sptr <TRIPRouteElement> aroute;
    int count = 0;
    cache = tribagent.getTribIn(*itadkey);
    adjTribInRouteSet = cache->getRouteSet(pKey);
    cerr << "Size of Trib In = " << adjTribInRouteSet->size() << " " << endl;
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet->begin();itr != adjTribInRouteSet->end(); itr++)
    {
        if ((*itr)->isAggregatedResult())
        {
            if (count == 0)
            {
                cerr << " first agg route " << ((*itr)->getPrefix()) << endl;
            }
            count++;
            aroute = (*itr);
        }
    }
    if (aroute.getPtr())
    {
        cerr << " last agg route " << aroute->getPrefix() << endl;
    }
}
