#include <stdio.h>
#include <unistd.h>

#include <iostream.h>

#include "TRIPUpdateMsg.hxx"
#include "IncomingPolicyAgent.hxx"
#include "LSSessionManager.hxx"
#include "NetworkAddress.h"
#include "TRIPItadKey.hxx"
#include "TRIPId.hxx"
#include "TRIBAgent.hxx"
#include "TRIPDef.hxx"
#include "cpLog.h"
#include "TimeTracker.hxx"
#include "Aggregator.hxx"

main()
{
    //TESTING ONLY
    //Create the UPdate Message
    TimeTracker t(cerr);
    Sptr <TRIPUpdateMsg> uMsg, uMsg2;
    uMsg = new TRIPUpdateMsg();
    uMsg2 = new TRIPUpdateMsg();
    Sptr<TRIPWithdrawnRoute> route1 = new TRIPWithdrawnRoute();
    Sptr<TRIPReachableRoute> route2 = new TRIPReachableRoute();
    Sptr<TRIPReachableRoute> route3 = new TRIPReachableRoute();

    TRIPRoutes tRoute(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1400"));
    TRIPRoutes tRoute1(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1401"));
    TRIPRoutes tRoute2(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1402"));
    TRIPRoutes tRoute3(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1403"));
    TRIPRoutes tRoute4(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1404"));
    TRIPRoutes tRoute5(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1405"));
    TRIPRoutes tRoute6(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1406"));
    TRIPRoutes tRoute7(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1407"));
    TRIPRoutes tRoute8(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1408"));
    TRIPRoutes tRoute9(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1409"));
    *route2 << tRoute;
    *route2 << tRoute1;
    *route2 << tRoute2;
    *route2 << tRoute3;
    *route2 << tRoute4;
    *route3 << tRoute5;
    *route3 << tRoute6;
    *route3 << tRoute7;
    *route3 << tRoute8;
    *route3 << tRoute9;

    uMsg->addWithdrawnRoute(route1);
    uMsg->addReachableRoute(route2);
    uMsg2->addWithdrawnRoute(route1);
    uMsg2->addReachableRoute(route3);

    TRIPItadPathSegment seg1(TRIP_SEG_AP_SET, 1224);
    seg1.addItad(1225);
    TRIPItadPathSegment seg11(TRIP_SEG_AP_SEQ, 1226);
    seg11.addItad(1227);
    seg11.addItad(1228);

    TRIPItadPathSegment seg2(TRIP_SEG_AP_SET, 2224);
    seg1.addItad(2225);
    TRIPItadPathSegment seg21(TRIP_SEG_AP_SEQ, 1226);
    seg21.addItad(1227);
    seg21.addItad(2229);

    Sptr<TRIPAdvertisePath> aPath = new TRIPAdvertisePath();
    *aPath << seg11 << seg1;
    Sptr<TRIPAdvertisePath> aPath1 = new TRIPAdvertisePath();
    *aPath1 << seg21 << seg2;

    TRIPItadPathSegment seg3(TRIP_SEG_AP_SET, 3224);
    seg3.addItad(3225);
    TRIPItadPathSegment seg31(TRIP_SEG_AP_SEQ, 3226);
    seg31.addItad(3227);
    TRIPItadPathSegment seg4(TRIP_SEG_AP_SET, 3228);
    seg4.addItad(3229);
    TRIPItadPathSegment seg41(TRIP_SEG_AP_SEQ, 3226);
    seg41.addItad(3227);
    
    Sptr<TRIPRoutedPath> aPath2 = new TRIPRoutedPath();
    *aPath2 << seg31 << seg3;
    Sptr<TRIPRoutedPath> aPath3 = new TRIPRoutedPath();
    *aPath3 << seg41 << seg4;

    cerr << "umsg - path" << endl;
    uMsg->addAttribute(aPath);
    uMsg->addAttribute(aPath2);
    cerr << "umsg2 - path" << endl;
    uMsg2->addAttribute(aPath1);
    uMsg2->addAttribute(aPath3);
    cerr << " - path" << endl;

    Sptr<TRIPNextHopServer> nServer = new TRIPNextHopServer(1223,
                                                      TRIPData("kevinmc-lnx:5060"));
    uMsg->addAttribute(nServer);
    uMsg2->addAttribute(nServer);

    Sptr<TRIPMultiExitDisc> newMultiExit = new TRIPMultiExitDisc(3098);

    uMsg->addAttribute(newMultiExit);
    uMsg2->addAttribute(newMultiExit);

    cerr << "uMSG" << *uMsg << endl;
    cerr << "uMSG2" << *uMsg2 << endl;


//    cerr << "Update Msg Created:" << uMsg << endl;

    LSSessionManager::instance(1234);
    u_int16_t itad = 10;
    char buf[256];
    strcpy(buf, "localhost");
    gethostname(buf, 256);
    NetworkAddress na(buf);
    Sptr <TRIPItadKey > itadkey = new TRIPItadKey(itad, TRIPId(na.getIp4Address ()));
    TRIBAgent& tribagent = TRIBAgent::instance();
    tribagent.createAdjTribIn(*itadkey, TC_EXTERNAL);

    Sptr <TRIPWorkSet> workSet = new TRIPWorkSet();
    Sptr <TRIPWorkSet> workSet2 = new TRIPWorkSet();
    TRIPProtoKey pKey(TRIP_APP_PROTO_SIP, TRIP_ADDR_POTS);
    //cpLogSetPriority(7);
    try
    {
        IncomingPolicyAgent& ipa = IncomingPolicyAgent::instance();
        t.startTime();
        ipa.process(uMsg, *itadkey, workSet);
        t.endTime();
        Sptr<TRIPTrieCache> cache = tribagent.getTribIn(*itadkey);
        Sptr<TRIPRouteSet> adjTribInRouteSet = cache->getRouteSet(pKey);
        cerr << "Size of Trib In = " << adjTribInRouteSet->size() << endl;
        t.startTime();
        ipa.process(uMsg2, *itadkey, workSet2);
        t.endTime();
        cache = tribagent.getTribIn(*itadkey);
        adjTribInRouteSet = cache->getRouteSet(pKey);
        cerr << "Size of Trib In = " << adjTribInRouteSet->size() << endl;
    }
    catch(VException& e)
    {
        cerr << "Caught exception:" << e.getDescription().c_str() << endl;
    }
    cerr << "Processing Complete" << endl;
    Sptr<TRIPTrieCache> cache = tribagent.getTribIn(*itadkey);
    Sptr<TRIPRouteSet> adjTribInRouteSet = cache->getRouteSet(pKey);
    cerr << "Size of Trib In = " << adjTribInRouteSet->size() << " " << endl;

    // Set the AGGR_BIT so that the routes are processed by aggregation
    adjTribInRouteSet = cache->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet->begin();itr != adjTribInRouteSet->end(); itr++)
    {
        cerr << "CHANGE ROUTES" << endl;
        (*itr)->setChanged(T_AGGR_BIT);
    }

    //cpLogSetPriority(7);
    cerr << "Begin aggregation" << endl;
    Sptr <Aggregator> aggAgt = new Aggregator();
    aggAgt->process(*cache);
    
    adjTribInRouteSet = cache->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet->begin();itr != adjTribInRouteSet->end(); itr++)
    {
        if ((*itr)->isAggregatedResult())
        cerr << "route" << (*(*itr)) << endl;
    }
    sleep(2);

}
