#include <stdio.h>
#include <unistd.h>

#include <iostream.h>

#include "TRIPUpdateMsg.hxx"
#include "IncomingPolicyAgent.hxx"
#include "DecisionProxyAgent.hxx"
#include "OutgoingPolicyAgent.hxx"
#include "TRIPUpdateEvent.hxx"
#include "LSSessionManager.hxx"
#include "NetworkAddress.h"
#include "TRIPItadKey.hxx"
#include "TRIPId.hxx"
#include "TRIBAgent.hxx"
#include "TRIPDef.hxx"
#include "cpLog.h"

main()
{
    //TESTING ONLY
    //Create the UPdate Message
    LSSessionManager::instance(1234);
    TRIPId id = LSSessionManager::instance().getTripId();
    u_int32_t seqNum = 8;
    u_int32_t seqNum2 = 9;
    u_int8_t flg = 0;
    flg |= TRIP_FLG_LINK_STATE;

    Sptr <TRIPUpdateMsg> uMsg = new TRIPUpdateMsg();
    Sptr<TRIPWithdrawnRoute> routew2 = new TRIPWithdrawnRoute();
    Sptr<TRIPWithdrawnRoute> routew3 = new TRIPWithdrawnRoute();
    Sptr<TRIPWithdrawnRoute> routew4 = new TRIPWithdrawnRoute(flg, id, seqNum2);
    Sptr<TRIPWithdrawnRoute> routew1 = new TRIPWithdrawnRoute(flg, id, seqNum);

    Sptr<TRIPReachableRoute> route3 = new TRIPReachableRoute();
    Sptr<TRIPReachableRoute> route2 = new TRIPReachableRoute();
    Sptr<TRIPReachableRoute> route1 = new TRIPReachableRoute(flg, id, seqNum);
    Sptr<TRIPReachableRoute> route4 = new TRIPReachableRoute();
    Sptr<TRIPReachableRoute> route5 = new TRIPReachableRoute();

    TRIPRoutes tRoute(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1401"));
    TRIPRoutes tRoute2(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("150"));
    TRIPRoutes tRoute3(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1503"));
    TRIPRoutes tRoute4(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1504"));
    TRIPRoutes tRoute5(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1505"));
    TRIPRoutes tRoute6(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1506"));
    TRIPRoutes tRoute7(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1507"));

    // Add route 1, 2, 3, 6  (internal Peer)
    *route1 << tRoute;
    *route1 << tRoute2;
    *route1 << tRoute3;
    *route1 << tRoute6;

    uMsg->addWithdrawnRoute(routew1);
    uMsg->addReachableRoute(route1);

    TRIPItadPathSegment seg1(TRIP_SEG_AP_SET, 1224);
    Sptr<TRIPAdvertisePath> aPath = new TRIPAdvertisePath();
    *aPath << seg1;

    TRIPItadPathSegment seg3(TRIP_SEG_AP_SET, 1222);
    Sptr<TRIPAdvertisePath> aPath3 = new TRIPAdvertisePath();
    *aPath3 << seg3;

    TRIPItadPathSegment seg2(TRIP_SEG_AP_SET, 1224);
    Sptr<TRIPRoutedPath> aPath2 = new TRIPRoutedPath();
    *aPath2 << seg2;

    Sptr <TRIPLocalPref> pref = new TRIPLocalPref(5);

    uMsg->addAttribute(aPath); 
    uMsg->addAttribute(aPath2);  
    
    Sptr<TRIPNextHopServer> nServer = new TRIPNextHopServer(1223,
                                                    TRIPData("129.234.34.56"));
    uMsg->addAttribute(nServer);
    uMsg->addAttribute(pref);

    cerr << "Update Msg Created:" << *uMsg << endl;

    u_int16_t itad = 10;
    char buf[256];
    strcpy(buf, "localhost");
    gethostname(buf, 256);
    NetworkAddress na(buf);
    Sptr <TRIPItadKey > itadkey = new TRIPItadKey(itad, TRIPId(na.getIp4Address ()));
    cerr << "OOOOOOOO" << endl;
    cerr << na.getIp4Address () << endl;
    TRIBAgent& tribagent = TRIBAgent::instance();
    tribagent.createAdjTribIn(*itadkey, TC_INTERNAL);
    Sptr<TRIPTrieCache> adj = tribagent.getTribIn(*itadkey);
    if (adj->isInternalRouteCache() == true)
    {
	cerr << "****INT" << endl;
    }
    else
    {
	cerr << "****EXT" << endl;
    }

    cpLogSetPriority(7);
    DecisionProxyAgent& decProxy = DecisionProxyAgent::instance();
    sleep(5);
    Sptr <TRIPUpdateEvent> update = new TRIPUpdateEvent(uMsg, *itadkey);
    decProxy.addToQueue(update);
    
    TRIPProtoKey pKey(TRIP_APP_PROTO_SIP, TRIP_ADDR_POTS);
    cerr << "Processing Complete" << endl;
    sleep(5);
    Sptr<TRIPTrieCache> cache = tribagent.getTribIn(*itadkey);
    Sptr <set<Sptr<TRIPRouteElement> > > adjTribInRouteSet = cache->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet->begin();itr != adjTribInRouteSet->end(); itr++)
    {
        cerr << "route" << (*(*itr)) << endl;
    }

    cerr << "ExtTRIB" << endl;
    Sptr <TRIPTrieCache> ext = tribagent.getExtTrib();
    Sptr< set<Sptr<TRIPRouteElement> > > extTribRouteSet = ext->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = extTribRouteSet->begin();itr != extTribRouteSet->end(); itr++)
    {
	cerr << "EXTroute" << (*(*itr)) << endl;
    }

    cerr << "LocTRIB" << endl;
    Sptr <TRIPTrieCache> loc = tribagent.getLocTrib();
    Sptr< set<Sptr<TRIPRouteElement> > > locTribRouteSet = loc->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = locTribRouteSet->begin();itr != locTribRouteSet->end(); itr++)
    {
        cerr << "LOCroute" << (*(*itr)) << endl;
    }



    Sptr <TRIPItadKey > itadkey2 = new TRIPItadKey(itad, TRIPId(229095));
    tribagent.createAdjTribIn(*itadkey2, TC_EXTERNAL);
    tribagent.createAdjTribOut(*itadkey2, TC_EXTERNAL);


    // add route 5, 6 (external peer)
    // withdraw route 1, 3 (do not exist - no effect)
    Sptr <TRIPUpdateMsg> uMsgw = new TRIPUpdateMsg();
    *routew2 << tRoute << tRoute3;
    *route3 << tRoute4 << tRoute5 << tRoute6;
    uMsgw->addWithdrawnRoute(routew2);
    uMsgw->addReachableRoute(route3);
    uMsgw->addAttribute(aPath);
    uMsgw->addAttribute(aPath2);
    uMsgw->addAttribute(nServer);

    cerr << "Update Msg Created:" << *uMsgw << endl;

    update = new TRIPUpdateEvent(uMsgw, *itadkey2);
    decProxy.addToQueue(update);
    sleep(5);

    cerr << "Processing 2 Complete" << endl;
    sleep(5);
    cache = tribagent.getTribIn(*itadkey2);
    adjTribInRouteSet = cache->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet->begin();itr != adjTribInRouteSet->end(); itr++)
    {
        cerr << "route" << (*(*itr)) << endl;
    }

    cerr << "ExtTRIB" << endl;
    Sptr <TRIPTrieCache> ext2 = tribagent.getExtTrib();
    extTribRouteSet = ext2->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = extTribRouteSet->begin();itr != extTribRouteSet->end(); itr++)
    {
        cerr << "EXTroute" << (*(*itr)) << endl;
    }

    cerr << "LocTRIB" << endl;
    Sptr <TRIPTrieCache> loc2 = tribagent.getLocTrib();
    locTribRouteSet = loc2->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = locTribRouteSet->begin();itr != locTribRouteSet->end(); itr++)
    {
        cerr << "LOCroute" << (*(*itr)) << endl;
    }

    // withdraw route 5 (external peer)
    Sptr <TRIPUpdateMsg> uMsgx = new TRIPUpdateMsg();
    *routew3 << tRoute5;
    uMsgx->addWithdrawnRoute(routew3);
    uMsgx->addReachableRoute(route4);
    uMsgx->addAttribute(aPath);
    uMsgx->addAttribute(aPath2);
    uMsgx->addAttribute(nServer);

    cerr << "Update Msg Created:" << *uMsgx << endl;

    update = new TRIPUpdateEvent(uMsgx, *itadkey2);
    decProxy.addToQueue(update);
    sleep(5);

    Sptr <TRIPUpdateMsg> uMsgy = new TRIPUpdateMsg();
    *routew4 << tRoute6;
    uMsgy->addWithdrawnRoute(routew4);
    uMsgy->addReachableRoute(route4);
    uMsgy->addAttribute(aPath);
    uMsgy->addAttribute(aPath2);
    uMsgy->addAttribute(nServer);

    cerr << "Update Msg Created:" << *uMsgy << endl;

    update = new TRIPUpdateEvent(uMsgy, *itadkey);
    decProxy.addToQueue(update);
    sleep(5);

    cerr << "Processing 3 Complete" << endl;

    cerr << "Internal AdjTribIn" << endl;
    cache = tribagent.getTribIn(*itadkey);
    adjTribInRouteSet = cache->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet->begin();itr != adjTribInRouteSet->end(); itr++)
    {
        cerr << "route" << (*(*itr)) << endl;
    }

    cerr << "External AdjTribIn" << endl;
    cache = tribagent.getTribIn(*itadkey2);
    adjTribInRouteSet = cache->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet->begin();itr != adjTribInRouteSet->end(); itr++)
    {
        cerr << "route" << (*(*itr)) << endl;
    }

    cerr << "ExtTRIB" << endl;
    Sptr <TRIPTrieCache> ext3 = tribagent.getExtTrib();
    extTribRouteSet = ext3->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = extTribRouteSet->begin();itr != extTribRouteSet->end(); itr++)
    {
        cerr << "EXTroute" << (*(*itr)) << endl;
    }

    cerr << "LocTRIB" << endl;
    Sptr <TRIPTrieCache> loc3 = tribagent.getLocTrib();
    locTribRouteSet = loc3->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = locTribRouteSet->begin();itr != locTribRouteSet->end(); itr++)
    {
        cerr << "LOCroute" << (*(*itr)) << endl;
    }

    OutgoingPolicyAgent::instance();
    sleep(45);

    cerr << "LocTRIB" << endl;
    Sptr <TRIPTrieCache> loc4 = tribagent.getLocTrib();
    locTribRouteSet = loc4->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = locTribRouteSet->begin();itr != locTribRouteSet->end(); itr++)
    {
        cerr << "LOCroute" << (*(*itr)) << endl;
    }

    Sptr <TRIPTrieCache> cache2 = tribagent.getTribOut(*itadkey2);

    Sptr <set<Sptr<TRIPRouteElement> > > adjTribInRouteSet2 = cache2->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet2->begin();itr != adjTribInRouteSet2->end(); itr++)
    {
        cerr << "Outroute" << (*(*itr)) << endl;
    }

    sleep(60);

}
