#include <stdio.h>
#include <unistd.h>

#include <iostream.h>

#include "TRIPUpdateMsg.hxx"
#include "IncomingPolicyAgent.hxx"
#include "LSSessionManager.hxx"
#include "NetworkAddress.h"
#include "TRIPItadKey.hxx"
#include "TRIPId.hxx"
#include "TRIBAgent.hxx"
#include "TRIPDef.hxx"
#include "cpLog.h"

main()
{
    //TESTING ONLY
    //Create the UPdate Message
    Sptr <TRIPUpdateMsg> uMsg;
    uMsg = new TRIPUpdateMsg();
    Sptr<TRIPWithdrawnRoute> routew1 = new TRIPWithdrawnRoute(TRIP_FLG_TRANSITIVE);
    Sptr<TRIPWithdrawnRoute> routew2 = new TRIPWithdrawnRoute(TRIP_FLG_TRANSITIVE);

    Sptr<TRIPReachableRoute> route1 = new TRIPReachableRoute(TRIP_FLG_TRANSITIVE);
    Sptr<TRIPReachableRoute> route2 = new TRIPReachableRoute(TRIP_FLG_TRANSITIVE);
    Sptr<TRIPReachableRoute> route3 = new TRIPReachableRoute(TRIP_FLG_TRANSITIVE);
    Sptr<TRIPReachableRoute> route4 = new TRIPReachableRoute(TRIP_FLG_TRANSITIVE);
    Sptr<TRIPReachableRoute> route5 = new TRIPReachableRoute(TRIP_FLG_TRANSITIVE);

    TRIPRoutes tRoute(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1401"));
    TRIPRoutes tRoute2(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("150"));
    TRIPRoutes tRoute3(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1503"));
    TRIPRoutes tRoute4(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1504"));
    TRIPRoutes tRoute5(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1505"));
    TRIPRoutes tRoute6(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1506"));
    TRIPRoutes tRoute7(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1507"));

    // Add route 1, 2, 3, 6
    *route1 << tRoute;
    *route1 << tRoute2;
    *route1 << tRoute3;
    *route1 << tRoute6;

    uMsg->addWithdrawnRoute(routew1);
    uMsg->addReachableRoute(route1);

    TRIPItadPathSegment seg1(TRIP_SEG_AP_SET, 1224);
    Sptr<TRIPAdvertisePath> aPath = new TRIPAdvertisePath(TRIP_FLG_TRANSITIVE);
    *aPath << seg1;

    TRIPItadPathSegment seg3(TRIP_SEG_AP_SET, 1222);
    Sptr<TRIPAdvertisePath> aPath3 = new TRIPAdvertisePath(TRIP_FLG_TRANSITIVE);
    *aPath3 << seg3;

    TRIPItadPathSegment seg2(TRIP_SEG_AP_SET, 1224);
    Sptr<TRIPRoutedPath> aPath2 = new TRIPRoutedPath(TRIP_FLG_TRANSITIVE);
    *aPath2 << seg2;

    uMsg->addAttribute(aPath); 
    uMsg->addAttribute(aPath2);  
    
    Sptr<TRIPNextHopServer> nServer = new TRIPNextHopServer(1223,
                                                      TRIPData("129.234.34.56"));
    uMsg->addAttribute(nServer);

    cerr << "Update Msg Created:" << *uMsg << endl;

    LSSessionManager::instance(1234);
    u_int16_t itad = 10;
    char buf[256];
    strcpy(buf, "localhost");
    gethostname(buf, 256);
    NetworkAddress na(buf);
    Sptr <TRIPItadKey > itadkey = new TRIPItadKey(itad, TRIPId(na.getIp4Address ()));
    TRIBAgent& tribagent = TRIBAgent::instance();
    tribagent.createAdjTribIn(*itadkey, TC_EXTERNAL);
    Sptr <TRIPWorkSet> workSet = new TRIPWorkSet();
    TRIPProtoKey pKey(TRIP_APP_PROTO_SIP, TRIP_ADDR_POTS);

    try
    {
        cpLogSetPriority(7);
        IncomingPolicyAgent& ipa = IncomingPolicyAgent::instance();
        ipa.process(uMsg, *itadkey, workSet);
    }
    catch(VException& e)
    {
        cerr << "Caught exception:" << e.getDescription().c_str() << endl;
    }
    cerr << "Processing Complete" << endl;
    Sptr<TRIPTrieCache> cache = tribagent.getTribIn(*itadkey);
    Sptr<TRIPRouteSet> adjTribInRouteSet = cache->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet->begin();itr != adjTribInRouteSet->end(); itr++)
    {
	cerr << "route" << (*(*itr)) << endl;
    }

    // add route 4, 5, 6
    // withdraw route 1, 3
    Sptr <TRIPUpdateMsg> uMsgw;
    uMsgw = new TRIPUpdateMsg();
    *routew1 << tRoute << tRoute3;
    *route3 << tRoute4 << tRoute5 << tRoute6;
    uMsgw->addWithdrawnRoute(routew1);
    uMsgw->addReachableRoute(route3);
    uMsgw->addAttribute(aPath);
    uMsgw->addAttribute(aPath2);
    uMsgw->addAttribute(nServer);
    Sptr <TRIPWorkSet> workSet2 = new TRIPWorkSet();
    try
    {
        cpLogSetPriority(7);
        IncomingPolicyAgent& ipa = IncomingPolicyAgent::instance();
        ipa.process(uMsgw, *itadkey, workSet2);
    }
    catch(VException& e)
    {
        cerr << "Caught exception:" << e.getDescription().c_str() << endl;
    }
    cerr << "Processing 2 Complete" << endl;
    cache = tribagent.getTribIn(*itadkey);
    adjTribInRouteSet = cache->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet->begin();itr != adjTribInRouteSet->end(); itr++)
    {
        cerr << "route" << (*(*itr)) << endl;
    }


    // add route 4 with different attribute
    // 4 should match previous route, 7 more spec not same attr
    Sptr <TRIPUpdateMsg> uMsgraw;
    uMsgraw = new TRIPUpdateMsg();
    *route4 << tRoute4 << tRoute7;
    uMsgraw->addWithdrawnRoute(routew2);
    uMsgraw->addReachableRoute(route4);
    uMsgraw->addAttribute(aPath3);
    uMsgraw->addAttribute(aPath2);
    uMsgraw->addAttribute(nServer);
    Sptr <TRIPWorkSet> workSet3 = new TRIPWorkSet();
    try
    {
        cpLogSetPriority(7);
        IncomingPolicyAgent& ipa = IncomingPolicyAgent::instance();
        ipa.process(uMsgraw, *itadkey, workSet3);
    }
    catch(VException& e)
    {
        cerr << "Caught exception:" << e.getDescription().c_str() << endl;
    }
    cerr << "Processing 3 Complete" << endl;
    cache = tribagent.getTribIn(*itadkey);
    adjTribInRouteSet = cache->getRouteSet(pKey);
    for(TRIPRouteSet::iterator itr = adjTribInRouteSet->begin();itr != adjTribInRouteSet->end(); itr++)
    {
        cerr << "route" << (*(*itr)) << endl;
    }


}
