#include <stdio.h>
#include <unistd.h>

#include <iostream.h>

#include "TRIPUpdateMsg.hxx"
#include "IncomingPolicyAgent.hxx"
#include "LSSessionManager.hxx"
#include "NetworkAddress.h"
#include "TRIPItadKey.hxx"
#include "TRIPId.hxx"
#include "TRIBAgent.hxx"
#include "TRIPDef.hxx"
#include "cpLog.h"
#include "TimeTracker.hxx"

main()
{
    //TESTING ONLY
    //Create the UPdate Message
    TimeTracker t(cerr);
    int NUM_MSG = 50;
    int NUM_RTES = 2000;
    Sptr <TRIPUpdateMsg> uMsg[50], uMsg2[50];
    Sptr<TRIPWithdrawnRoute> route1 = new TRIPWithdrawnRoute(TRIP_FLG_TRANSITIVE);
    Sptr<TRIPReachableRoute> route2 = new TRIPReachableRoute(TRIP_FLG_TRANSITIVE);
    Sptr<TRIPReachableRoute> route3 = new TRIPReachableRoute(TRIP_FLG_TRANSITIVE);

    TRIPRoutes tRoute(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1408"));
    TRIPRoutes tRoute2(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1508"));
    TRIPRoutes tRoute3(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1608"));
    TRIPRoutes tRoute4(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1708"));
    TRIPRoutes tRoute5(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("16081"));
//    *route1 << tRoute;
    *route2 << tRoute2;
    *route2 << tRoute3;
    *route2 << tRoute4;
    *route2 << tRoute5;

    int d1=0, d2=0, d3=0, d4=0, d5 = 0;;
    string sStr;
    for (int j=0; j < NUM_MSG; j++)
    {
        uMsg[j] = new TRIPUpdateMsg();
        uMsg2[j] = new TRIPUpdateMsg();        
        for(int i = j*NUM_RTES ; i < (j+1)*NUM_RTES; i++)
        {
            char buf[256];
            sprintf(buf, "%d%d%d%d%d", d1, d2, d3, d4, d5);
            TRIPRoutes tRoute6(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData(buf));
            if (i%2 == 0)
            {
                *route3 << tRoute6;
            }
            else
            {
                *route2 << tRoute6;
            }
            d5++;
            if(d5 >= 10) { d5 = 0; d4++; };
            if(d4 >= 10) { d5 = 0; d4 = 0; d3++; };
            if(d3 >= 10) { d4 = 0; d3 = 0; d2++; };
            if(d2 >= 10) { d4 = 0; d3 = 0; d2 = 0; d1++; };
            if(d1 >= 10) { break; };
            if(i == 50000) sStr = buf;
        }

        uMsg[j]->addWithdrawnRoute(route1);
        uMsg[j]->addReachableRoute(route2);
        uMsg2[j]->addWithdrawnRoute(route1);
        uMsg2[j]->addReachableRoute(route3);

        TRIPItadPathSegment seg1(TRIP_SEG_AP_SET, 1224);
        Sptr<TRIPAdvertisePath> aPath = new TRIPAdvertisePath(TRIP_FLG_TRANSITIVE);
        *aPath << seg1;
        Sptr<TRIPAdvertisePath> aPath1 = new TRIPAdvertisePath(TRIP_FLG_TRANSITIVE);
        *aPath1 << seg1;

        TRIPItadPathSegment seg2(TRIP_SEG_AP_SET, 1224);
        Sptr<TRIPRoutedPath> aPath2 = new TRIPRoutedPath(TRIP_FLG_TRANSITIVE);
        *aPath2 << seg2;
        Sptr<TRIPRoutedPath> aPath3 = new TRIPRoutedPath(TRIP_FLG_TRANSITIVE);
        *aPath3 << seg2;

        uMsg[j]->addAttribute(aPath);
        uMsg[j]->addAttribute(aPath2);
        uMsg2[j]->addAttribute(aPath1);
        uMsg2[j]->addAttribute(aPath3);

        Sptr<TRIPNextHopServer> nServer = new TRIPNextHopServer(1223,
                                                      TRIPData("ganesh:5060"),
                                                        TRIP_FLG_TRANSITIVE);
        uMsg[j]->addAttribute(nServer);
        uMsg2[j]->addAttribute(nServer);

        route2 = new TRIPReachableRoute(TRIP_FLG_TRANSITIVE);
        route3 = new TRIPReachableRoute(TRIP_FLG_TRANSITIVE);
    }
    LSSessionManager::instance(1234);
    u_int16_t itad = 10;
    char buf[256];
    strcpy(buf, "localhost");
    gethostname(buf, 256);
    NetworkAddress na(buf);
    Sptr <TRIPItadKey > itadkey = new TRIPItadKey(itad, TRIPId(na.getIp4Address ()));
    TRIBAgent& tribagent = TRIBAgent::instance();
    tribagent.createAdjTribIn(*itadkey, TC_EXTERNAL);

    //cpLogSetPriority(7);
    Sptr <TRIPWorkSet> workSet = new TRIPWorkSet();
    Sptr <TRIPWorkSet> workSet2 = new TRIPWorkSet();
    TRIPProtoKey pKey(TRIP_APP_PROTO_SIP, TRIP_ADDR_POTS);
    try
    {
        IncomingPolicyAgent& ipa = IncomingPolicyAgent::instance();
        cerr << "Inserting in to adjTrib In... " << endl;
        t.startTime();
        for (int j = 0; j < NUM_MSG; j++)
        {
            ipa.process(uMsg[j], *itadkey, workSet);
            workSet = new TRIPWorkSet();
        }
        t.endTime();
        Sptr<TRIPTrieCache> cache = tribagent.getTribIn(*itadkey);
        Sptr<TRIPRouteSet> adjTribInRouteSet = cache->getRouteSet(pKey);
        cerr << "Size of Trib In = " << adjTribInRouteSet->size() << endl;
        cerr << "Inserting more in to adjTrib In... " << endl;
        t.startTime();
        for (int j = 0; j < NUM_MSG; j++)
        {
            ipa.process(uMsg2[j], *itadkey, workSet2);
            workSet2 = new TRIPWorkSet();
        }
        t.endTime();
        cache = tribagent.getTribIn(*itadkey);
        adjTribInRouteSet = cache->getRouteSet(pKey);
        cerr << "Size of Trib In = " << adjTribInRouteSet->size() << endl;
    }
    catch(VException& e)
    {
        cerr << "Caught exception:" << e.getDescription().c_str() << endl;
    }
    cerr << "Processing Complete" << endl;
    Sptr<TRIPTrieCache> cache = tribagent.getTribIn(*itadkey);
    Sptr<TRIPRouteSet> adjTribInRouteSet = cache->getRouteSet(pKey);
    cerr << "Size of Trib In = " << adjTribInRouteSet->size() << " " << endl;

}
