#include <stdio.h>
#include <unistd.h>

#include <iostream.h>

#include "TRIPUpdateMsg.hxx"
#include "IncomingPolicyAgent.hxx"
#include "DecisionProxyAgent.hxx"
#include "OutgoingPolicyAgent.hxx"
#include "TRIPUpdateEvent.hxx"
#include "LSSessionManager.hxx"
#include "NetworkAddress.h"
#include "TRIPItadKey.hxx"
#include "TRIPId.hxx"
#include "TRIBAgent.hxx"
#include "TRIPDef.hxx"
#include "LSTopology.hxx"
#include "TimeTracker.hxx"
#include "cpLog.h"

main()
{
    TimeTracker t(cerr);
    cpLogSetPriority(7);
    TRIPId id(111);
    Sptr <LSTopology> top = new LSTopology(id);
    u_int32_t seqNum2 = 8;
    u_int32_t seqNum3 = 9;
    u_int32_t seqNum4 = 10;
    u_int8_t flg = 0;
    flg |= TRIP_FLG_LINK_STATE;

    top->addConnection(id, TRIPId(245));
    top->addConnection(id, TRIPId(246));
    top->addConnection(id, TRIPId(247));

    cerr << *top << endl;
    
    LSConnectionList added2, removed2;
    Sptr<TRIPItadTopology> top2 = new TRIPItadTopology(TRIPId(245), seqNum2, flg);
    top2->addTripId(TRIPId(247));
    top2->addTripId(TRIPId(id));
    top2->addTripId(TRIPId(244));
    cerr << "top2" << *top2 << endl;

    t.startTime();
    top->updateTopology(top2, added2, removed2);
    t.endTime();
    Sptr <LSConnectionList> conn = top->getConnectionList(TRIPId(245));
    for (LSConnectionList::const_iterator itr = conn->begin();
                                            itr != conn->end(); itr++)
    {
        cerr << "245 connsected to " << (*itr) << endl;
    }
    cerr << *top << endl;
    cerr << "Source : " << top2->getTripId() << endl;
    cerr << "added2" << endl;
    for (LSConnectionList::const_iterator itr = added2.begin(); itr != added2.end(); itr++)
    {
        cerr << (*itr).getId() << endl;
    }
    cerr << "removed2" << endl;
    for (LSConnectionList::const_iterator itr = removed2.begin(); itr != removed2.end(); itr++)
    {
        cerr << (*itr).getId() << endl;
    }
    LSConnectionList removeList;
    top->removeConnection(TRIPId(245), removeList);
    if (removeList.size() > 0)
    {
        cerr << "something not reachable" << endl;
    }
    cerr << *top << endl;

    if (top->isConnected(TRIPId(245), TRIPId(247)))
    {
        cerr << "245 & 247 Connected" << endl;
    }

    LSConnectionList added4, removed4;
    Sptr<TRIPItadTopology> top4 = new TRIPItadTopology(TRIPId(247), seqNum3, flg);
    top4->addTripId(id);
    top4->addTripId(TRIPId(246));
    cerr << "top4" << *top4 << endl;

    t.startTime();
    top->updateTopology(top4, added4, removed4);
    t.endTime();
    cerr << *top << endl;
    cerr << "Source : " << top4->getTripId() << endl;
    cerr << "added4" << endl;
    for (LSConnectionList::const_iterator itr = added4.begin(); itr != added4.end(); itr++)
    {
        cerr << (*itr).getId() << endl;
    }
    cerr << "removed4" << endl;
    for (LSConnectionList::const_iterator itr = removed4.begin(); itr != removed4.end(); itr++)
    {
        cerr << (*itr).getId() << endl;
    }

    if (top->isConnected(TRIPId(245), TRIPId(247)))
    {
        cerr << "245 & 247 Connected" << endl;
    }

    top->addConnection(id, TRIPId(245));
    cerr << *top << endl;

    LSConnectionList added5, removed5;
    Sptr<TRIPItadTopology> top5 = new TRIPItadTopology(TRIPId(245), seqNum4, flg);
    top5->addTripId(id);
    top5->addTripId(TRIPId(244));
    cerr << "top5" << *top5 << endl;

    t.startTime();
    top->updateTopology(top5, added5, removed5);
    t.endTime();
    cerr << *top << endl;
    cerr << "Source : " << top5->getTripId() << endl;
    cerr << "added5" << endl;
    for (LSConnectionList::const_iterator itr = added5.begin(); itr != added5.end(); itr++)
    {
        cerr << (*itr).getId() << endl;
    }
    cerr << "removed5" << endl;
    for (LSConnectionList::const_iterator itr = removed5.begin(); itr != removed5.end(); itr++)
    {
        cerr << (*itr).getId() << endl;
    }

    cerr << endl << endl << "Now removeConnection 111 - 245" << endl;
    LSConnectionList removeLst;
    top->removeConnection(TRIPId(245), removeLst);
    if (removeLst.size() > 0)
    {
        cerr << "something not reachable" << endl;
        for (LSConnectionList::const_iterator itr = removeLst.begin(); itr != removeLst.end(); itr++)
        {
            cerr << (*itr).getId() << endl;
        }
    }
    cerr << *top << endl;

}
