#include <stdio.h>
#include <unistd.h>

#include <iostream.h>

#include "TRIPUpdateMsg.hxx"
#include "IncomingPolicyAgent.hxx"
#include "LSSessionManager.hxx"
#include "TRIPRouteElement.hxx"
#include "NetworkAddress.h"
#include "TRIPItadKey.hxx"
#include "TRIPId.hxx"
#include "TRIBAgent.hxx"
#include "TRIPDef.hxx"
#include "cpLog.h"

main()
{
    //TESTING ONLY
    //Create the TRIPRouteElement
    TRIPUpdateMsg uMsg;

    TRIPRoutes tRoute(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1401"));

    TRIPItadPathSegment seg1(TRIP_SEG_AP_SET, 1224);
    Sptr<TRIPAdvertisePath> aPath = new TRIPAdvertisePath(TRIP_FLG_TRANSITIVE);
    *aPath << seg1;

    TRIPItadPathSegment seg3(TRIP_SEG_AP_SET, 1222);
    Sptr<TRIPAdvertisePath> aPath3 = new TRIPAdvertisePath(TRIP_FLG_TRANSITIVE);
    *aPath3 << seg3;

    TRIPItadPathSegment seg2(TRIP_SEG_AP_SET, 1224);
    Sptr<TRIPRoutedPath> aPath2 = new TRIPRoutedPath(TRIP_FLG_TRANSITIVE);
    *aPath2 << seg2;

    Sptr<TRIPNextHopServer> nServer = new TRIPNextHopServer(1223,
                                                      TRIPData("129.234.34.56"),
                                                        TRIP_FLG_TRANSITIVE);


    //LSSessionManager& manager = LSSessionManager::instance(1234);
    u_int16_t itad = 10;
    char buf[256];
    strcpy(buf, "localhost");
    gethostname(buf, 256);
    NetworkAddress na(buf);
    Sptr <TRIPItadKey > itadkey = new TRIPItadKey(itad, TRIPId(na.getIp4Address ()));

    Data newNextHopData = nServer->getHopAddress().getData();
    
    Sptr <TRIPRouteElement> newRoute = new TRIPRouteElement(*itadkey, tRoute, newNextHopData);

    newRoute->addAttribute(nServer);
    newRoute->addAttribute(aPath);
    newRoute->addAttribute(aPath2);

    newRoute->setChanged(T_UPDATE_BIT);
    newRoute->setChanged(T_UPDATE_BIT);
    newRoute->unsetChanged(RouteChangeBitMask(T_UPDATE_BIT));
    newRoute->setChanged(T_FLOOD_BIT);
    newRoute->unsetChanged(RouteChangeBitMask(T_UPDATE_BIT));

    cerr << "route with Flood bit set" << *newRoute << endl;

    newRoute->setChanged(T_ALL_BIT);
    cerr << "route all change bits set" << *newRoute << endl;
    newRoute->unsetChanged(T_ALL_BIT);
    cerr << "route all change bits unset" << *newRoute << endl;
    newRoute->unsetChanged(T_ALL_BIT);
    cerr << "route all change bits unset again" << *newRoute << endl;
    

    if (newRoute->isChanged(RouteChangeBitMask(T_UPDATE_BIT)))
    {
        cerr << "changed - update bit set - INCORRECT" << endl;
    }
    else
    {
        cerr << "changed - update bit not set - CORRECT" << *newRoute << endl;
    }

}
