#include <stdio.h>
#include <unistd.h>

#include <iostream.h>

#include "TRIPTrieCache.hxx"
#include "TRIPUpdateMsg.hxx"
#include "LSSessionManager.hxx"
#include "LSPeerSession.hxx"
#include "TRIPTrieElement.hxx"
#include "LSUtils.hxx"
#include "cpLog.h"
#include "TimeTracker.hxx"

main()
{
    //cpLogSetPriority(7);
    //TESTING ONLY
    //Create the UPdate Message
    cerr << "Creating routes:" << endl;
    TimeTracker t(cerr);

    const int NUM_MSG = 50;
    const int NUM_RTES = 2000;
    t.startTime();
    TRIPUpdateMsg uMsg[NUM_MSG];
    Sptr<TRIPWithdrawnRoute> route1 = new TRIPWithdrawnRoute();
    Sptr<TRIPReachableRoute> route2 = new TRIPReachableRoute();
    TRIPRoutes tRoute(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1408"));
    TRIPRoutes tRoute2(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1508"));
    TRIPRoutes tRoute3(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("16081"));
    TRIPRoutes tRoute4(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1708"));
    TRIPRoutes tRoute5(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1608"));
    *route2 << tRoute2;
    *route2 << tRoute3;
    *route2 << tRoute4;
    *route2 << tRoute5;

    int d1=0, d2=0, d3=0, d4=0, d5 = 0;;
    string sStr;

    for (int j = 0; j < NUM_MSG; j++)
    {
        for(int i = j*NUM_RTES ; i < (j+1)*NUM_RTES; i++)
        {
            char buf[256];
            sprintf(buf, "%d%d%d%d%d", d1, d2, d3, d4, d5);
            TRIPRoutes tRoute6(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData(buf));
            *route2 << tRoute6;
            d5++;
            if(d5 >= 10) { d5 = 0; d4++; };
            if(d4 >= 10) { d5 = 0; d4 = 0; d3++; };
            if(d3 >= 10) { d4 = 0; d3 = 0; d2++; };
            if(d2 >= 10) { d4 = 0; d3 = 0; d2 = 0; d1++; };
            if(d1 >= 10) { break; };
            if(i == 50000) sStr = buf;
        }



        uMsg[j].addWithdrawnRoute(route1);
        uMsg[j].addReachableRoute(route2);

        TRIPItadPathSegment seg1(TRIP_SEG_AP_SET, 1224);
        Sptr<TRIPAdvertisePath> aPath = new TRIPAdvertisePath(TRIP_FLG_TRANSITIVE);
        *aPath << seg1;

        TRIPItadPathSegment seg2(TRIP_SEG_AP_SET, 1224);
        Sptr<TRIPRoutedPath> aPath2 = new TRIPRoutedPath(TRIP_FLG_TRANSITIVE);
        *aPath2 << seg2;

        uMsg[j].addAttribute(aPath); 
        uMsg[j].addAttribute(aPath2);  
    
        Sptr<TRIPNextHopServer> nServer = new TRIPNextHopServer(1223,
                                                      TRIPData("ganesh:5060"),
							TRIP_FLG_TRANSITIVE);
        uMsg[j].addAttribute(nServer);
        route2 = new TRIPReachableRoute();
    }
    t.endTime();
    
    //cerr << "Update Msg:" << uMsg << endl;

    cerr << "Translating :" << endl;
    t.startTime();
    TRIPItadKey key(1234, 2233);
    Sptr< set<Sptr<TRIPRouteElement> > > rSet[NUM_MSG];
    for (int j = 0; j < NUM_MSG; j++)
    {
        rSet[j] = LSUtils::translateRoutes(key, uMsg[j]);
        cerr << " Size: " << rSet[j]->size();
    }
    cerr << endl;
    t.endTime();
    TRIPTrieCache tCache;
    Sptr<TRIPRouteElement> elem;
    set<Sptr<TRIPRouteElement> >::iterator itr;
    cerr << "Putting in cache:" << endl;
    t.startTime();
    
    for (int j = 0; j < NUM_MSG; j++)
    {
        if(rSet[j].getPtr() != 0)
        {
            for(itr = rSet[j]->begin(); itr != rSet[j]->end(); itr++)
            {
                //cerr << "Inserting" << endl;
                tCache.insert((*itr));
                if((*itr)->getPrefix() == "16081")
                    elem = (*itr);
                //cerr << *(*itr) << endl;
            }
        }
    }
    t.endTime();
    TRIPProtoKey pKey(TRIP_APP_PROTO_SIP, TRIP_ADDR_POTS);
    Sptr<TRIPRouteSet> adjTribInRouteSet = tCache.getRouteSet(pKey);
    cerr << "Size of Trib In = " << adjTribInRouteSet->size() << " " << endl;

        //cerr << tCache << endl;
        //t.startTime();
        //string nHop = tCache.getNextHopServer(sStr);
        //if(nHop.length()) cerr << "****NEXT HOP:" << nHop.c_str() << endl;
        //t.endTime();

    t.startTime();
    bool sameAttr;
    TRIPRouteSet aSet;
    cerr << "Route:" << endl;
    elem->prettyDump(cerr);
    if(tCache.moreSpecific(elem, aSet, sameAttr))
    {
        cerr << "More specific" << endl;
    }
    else
    {
        cerr << "Less specific" << endl;
    }
    t.endTime();

    t.startTime();
    Sptr<set<Sptr<TRIPRouteElement> > > retSet2 = tCache.getRouteSet(pKey);
    int x = 0;
    for(TRIPRouteSet::const_iterator itr = retSet2->begin();
                                    itr != retSet2->end(); itr++)
    {
        if ((*itr)->isAggregated()) continue;
        if ((*itr)->isAggregatedResult()) continue;
        Sptr <TRIPRouteElement> elem = new TRIPRouteElement(*(*itr));
        tCache.insert((*itr));
        x++;
    }
    cerr << "Size:" << retSet2->size() << endl;
    cerr << "X" << x << endl; 
    t.endTime();
}
