#include <stdio.h>
#include <unistd.h>

#include <iostream.h>

#include "TRIPUpdateMsg.hxx"
#include "LSSessionManager.hxx"
#include "LSPeerSession.hxx"
#include "cpLog.h"

main()
{
    //TESTING ONLY
    //Create the UPdate Message
        cpLogSetPriority(7);
    LSSessionManager& manager = LSSessionManager::instance(1234);

    TRIPUpdateMsg uMsg;
    Sptr<TRIPWithdrawnRoute> route1 = new TRIPWithdrawnRoute(TRIP_FLG_LINK_STATE, manager.getTripId(), 2);
    Sptr<TRIPReachableRoute> route2 = new TRIPReachableRoute(TRIP_FLG_LINK_STATE, manager.getTripId(), 2);
    TRIPRoutes tRoute(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1408"));
    TRIPRoutes tRoute2(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1508"));
    TRIPRoutes tRoute3(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1608"));
    *route1 << tRoute;
    *route2 << tRoute2;
    *route2 << tRoute3;

    int d1=0, d2=0, d3=0, d4=0, d5 = 0;;
    string sStr;

    for(int i = 0 ; i < 1000; i++)
    {
        char buf[256];
        sprintf(buf, "%d%d%d%d%d", d1, d2, d3, d4, d5);
        TRIPRoutes tRoute6(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData(buf));
        *route2 << tRoute6;
        d5++;
        if(d5 >= 10) { d5 = 0; d4++; };
        if(d4 >= 10) { d5 = 0; d4 = 0; d3++; };
        if(d3 >= 10) { d4 = 0; d3 = 0; d2++; };
        if(d2 >= 10) { d4 = 0; d3 = 0; d2 = 0; d1++; };
        if(d1 >= 10) { break; };
    }


    uMsg.addWithdrawnRoute(route1);
    uMsg.addReachableRoute(route2);

    TRIPItadPathSegment seg1(TRIP_SEG_AP_SET, 1223);
    Sptr<TRIPAdvertisePath> aPath = new TRIPAdvertisePath();
    *aPath << seg1;

    TRIPItadPathSegment seg2(TRIP_SEG_AP_SET, 1223);
    Sptr<TRIPRoutedPath> aPath2 = new TRIPRoutedPath();
    *aPath2 << seg2;

    uMsg.addAttribute(aPath); 
    uMsg.addAttribute(aPath2);  
    
    Sptr<TRIPNextHopServer> nServer = new TRIPNextHopServer(1223,
                                                      TRIPData("129.234.34.56"));
    uMsg.addAttribute(nServer);

    u_int32_t val = 16;
    Sptr<TRIPLocalPref> pref = new TRIPLocalPref(val);
    uMsg.addAttribute(pref);


    cerr << "Update Msg:" << uMsg << endl;
    try
    {
        cpLogSetPriority(7);
        Sptr<TRIPItadTopology> iTopo = new TRIPItadTopology(manager.getTripId(), 2, TRIP_FLG_LINK_STATE);
        iTopo->addTripId(manager.getTripId());
    
        uMsg.addAttribute(iTopo);
        manager.threadRun();
        while(1)
        {
            sleep(2);
            cerr << "Sending update" << endl;
            const LSPeerList& lsList = manager.getSessionList();
            LSPeerList::const_iterator itr;
            for(itr = lsList.begin(); itr != lsList.end(); itr++)
            {
                (*itr)->sendUpdate(uMsg);
            }
        }
    }
    catch(VException& e)
    {
        cerr << "Caught exception:" << e.getDescription().c_str() << endl;
    }

}
