#include <stdio.h>
#include <unistd.h>

#include <iostream.h>

#include "TRIPUpdateMsg.hxx"
#include "LSSessionManager.hxx"
#include "LSPeerSession.hxx"
#include "cpLog.h"

main(int argc, char**argv )
{
    if(argc < 4) 
    {
        cerr << "Usage:" << argv[0] << " <ItadNumber>" << " <startDest>" << " <endDest>" << " [<iterations>]" << endl;
        exit(-1);
    }
    if(argc > 5)
    {
        cerr << "Usage:" << argv[0] << " <ItadNumber>" << " <startDest>" << " <endDest>" << " [<iterations>]" << endl;
        exit(-1);
    }
    u_int16_t itad = atoi(argv[1]);
    int first = atoi(argv[2]);
    cerr << "first " << first << endl;
    int last = atoi(argv[3]);
    int iters = 0;
    if (argc == 5)
    {
        iters = atoi(argv[4]);
    }
    cerr << "last " << last << endl;
    if (first > last)
    {
        cerr << "startDest should be less than endDest" << endl;
        exit(-1);
    }
    if (first < 0)
    {
        cerr << "startDest should be greater than or equal 0" << endl;
        exit(-1);
    }
    if ((first > 99999) || (last > 99999))
    {
        cerr << "startDest and endDest should be less than or equal 99999" << endl;
        exit(-1);
    }
    cerr << "Itad:" << static_cast<int>(itad) << endl;
    //Create the UPdate Message
    cpLogSetPriority(7);
    LSSessionManager& manager = LSSessionManager::instance(itad);

    TRIPUpdateMsg uMsg;
    Sptr<TRIPWithdrawnRoute> route1 = new TRIPWithdrawnRoute();
    Sptr<TRIPReachableRoute> route2 = new TRIPReachableRoute();
    TRIPRoutes tRoute(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1408"));
    TRIPRoutes tRoute2(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1508"));
    TRIPRoutes tRoute3(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1608"));
    *route1 << tRoute;
    *route2 << tRoute2;
    *route2 << tRoute3;
    int d1, d2, d3, d4, d5;
    if (first == 0)
    {
        cerr << "first = 0" << endl;
        d1=d2=d3=d4=d5=0;
    }
    else
    {
        cerr << "first to be set" << endl;
        d1=(first/10000)%10;
        d2=(first/1000)%10;
        d3=(first/100)%10;
        d4=(first/10)%10;
        d5=first%10;
        cerr << "Num is" << d1 << d2 << d3 << d4 << d5 << endl;
    }
    string sStr;

    for(int i = first; i < last; i++)
    {
        char buf[256];
        sprintf(buf, "%d%d%d%d%d", d1, d2, d3, d4, d5);
        TRIPRoutes tRoute6(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData(buf));
        *route2 << tRoute6;
        d5++;
        if(d5 >= 10) { d5 = 0; d4++; };
        if(d4 >= 10) { d5 = 0; d4 = 0; d3++; };
        if(d3 >= 10) { d4 = 0; d3 = 0; d2++; };
        if(d2 >= 10) { d4 = 0; d3 = 0; d2 = 0; d1++; };
        if(d1 >= 10) { break; };
    }


    uMsg.addWithdrawnRoute(route1);
    uMsg.addReachableRoute(route2);

    TRIPItadPathSegment seg1(TRIP_SEG_AP_SET, 5000);
    Sptr<TRIPAdvertisePath> aPath = new TRIPAdvertisePath();
    *aPath << seg1;

    TRIPItadPathSegment seg2(TRIP_SEG_AP_SET, 5000);
    Sptr<TRIPRoutedPath> aPath2 = new TRIPRoutedPath();
    *aPath2 << seg2;

    uMsg.addAttribute(aPath); 
    uMsg.addAttribute(aPath2);  
    
    Sptr<TRIPNextHopServer> nServer = new TRIPNextHopServer(itad,
                                                      TRIPData("kevinmc-lnx:5060"));
    cerr << "NEXTHOP" << *nServer << endl;
    uMsg.addAttribute(nServer);

    cerr << "Update Msg:" << uMsg << endl;
    try
    {
        cpLogSetPriority(7);
        manager.threadRun();
        int pref = 234;
        int count = 0;
        while(1)
        {
            sleep(2);
            cerr << "Sending update" << endl;
            const LSPeerList& lsList = manager.getSessionList();
            LSPeerList::const_iterator itr;
            for(itr = lsList.begin(); itr != lsList.end(); itr++)
            {
                (*itr)->sendUpdate(uMsg);
            }
            if (iters > 0)
            {
                if (++count == iters)
                {
                    while(1)
                    {
                        sleep(2);
                    }
                }
            }
        }
    }
    catch(VException& e)
    {
        cerr << "Caught exception:" << e.getDescription().c_str() << endl;
    }

}
