/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */


static const char* const TimeDataCreation_cxx_Version = 
    "$Id: TimeDataCreation.cxx,v 1.2 2001/03/15 20:18:31 bko Exp $";

#include "PerfDuration.hxx"
#include "PerformanceDb.hxx"
#include "Data.hxx"
#include "CopyOnWriteData.hxx"

using Vocal::Statistics::PerfDuration;
using Vocal::Statistics::PerformanceDb;

class BigDataContainer
{
    public:
	BigDataContainer();

    private:
	Data a0;
	Data a1;
	Data a2;
	Data a3;
	Data a4;
	Data a5;
	Data a6;
	Data a7;
	Data a8;
	Data a9;
	Data a10;
	Data a11;
	Data a12;
	Data a13;
	Data a14;
	Data a15;
	Data a16;
	Data a17;
	Data a18;
	Data a19;
	Data a20;
	Data a21;
	Data a22;
	Data a23;
	Data a24;
	Data a25;
	Data a26;
	Data a27;
	Data a28;
	Data a29;
	Data a30;
	Data a31;
	Data a32;
	Data a33;
	Data a34;
	Data a35;
	Data a36;
	Data a37;
	Data a38;
	Data a39;
	Data a40;
	Data a41;
	Data a42;
	Data a43;
	Data a44;
	Data a45;
	Data a46;
	Data a47;
	Data a48;
	Data a49;
	Data a50;
	Data a51;
	Data a52;
	Data a53;
	Data a54;
	Data a55;
	Data a56;
	Data a57;
	Data a58;
	Data a59;
	Data a60;
	Data a61;
	Data a62;
	Data a63;
	Data a64;
	Data a65;
	Data a66;
	Data a67;
	Data a68;
	Data a69;
	Data a70;
	Data a71;
	Data a72;
	Data a73;
	Data a74;
	Data a75;
	Data a76;
	Data a77;
	Data a78;
	Data a79;
	Data a80;
	Data a81;
	Data a82;
	Data a83;
	Data a84;
	Data a85;
	Data a86;
	Data a87;
	Data a88;
	Data a89;
	Data a90;
	Data a91;
	Data a92;
	Data a93;
	Data a94;
	Data a95;
	Data a96;
	Data a97;
	Data a98;
	Data a99;
	Data a100;
	Data a101;
	Data a102;
	Data a103;
	Data a104;
	Data a105;
	Data a106;
	Data a107;
	Data a108;
	Data a109;
	Data a110;
	Data a111;
	Data a112;
	Data a113;
	Data a114;
	Data a115;
	Data a116;
	Data a117;
	Data a118;
	Data a119;
	Data a120;
	Data a121;
	Data a122;
	Data a123;
	Data a124;
	Data a125;
	Data a126;
	Data a127;
	Data a128;
	Data a129;
	Data a130;
	Data a131;
	Data a132;
	Data a133;
	Data a134;
	Data a135;
	Data a136;
	Data a137;
	Data a138;
	Data a139;
	Data a140;
	Data a141;
	Data a142;
	Data a143;
	Data a144;
	Data a145;
	Data a146;
	Data a147;
	Data a148;
	Data a149;
	Data a150;
	Data a151;
	Data a152;
	Data a153;
	Data a154;
	Data a155;
	Data a156;
	Data a157;
	Data a158;
	Data a159;
	Data a160;
	Data a161;
	Data a162;
	Data a163;
	Data a164;
	Data a165;
	Data a166;
	Data a167;
	Data a168;
	Data a169;
	Data a170;
	Data a171;
	Data a172;
	Data a173;
	Data a174;
	Data a175;
	Data a176;
	Data a177;
	Data a178;
	Data a179;
	Data a180;
	Data a181;
	Data a182;
	Data a183;
	Data a184;
	Data a185;
	Data a186;
	Data a187;
	Data a188;
	Data a189;
	Data a190;
	Data a191;
	Data a192;
	Data a193;
	Data a194;
	Data a195;
	Data a196;
	Data a197;
	Data a198;
	Data a199;
	Data a200;
	Data a201;
	Data a202;
	Data a203;
	Data a204;
	Data a205;
	Data a206;
	Data a207;
	Data a208;
	Data a209;
	Data a210;
	Data a211;
	Data a212;
	Data a213;
	Data a214;
	Data a215;
	Data a216;
	Data a217;
	Data a218;
	Data a219;
	Data a220;
	Data a221;
	Data a222;
	Data a223;
	Data a224;
	Data a225;
	Data a226;
	Data a227;
	Data a228;
	Data a229;
	Data a230;
	Data a231;
	Data a232;
	Data a233;
	Data a234;
	Data a235;
	Data a236;
	Data a237;
	Data a238;
	Data a239;
	Data a240;
	Data a241;
	Data a242;
	Data a243;
	Data a244;
	Data a245;
	Data a246;
	Data a247;
	Data a248;
	Data a249;
	Data a250;
	Data a251;
	Data a252;
	Data a253;
	Data a254;
	Data a255;
	Data a256;
	Data a257;
	Data a258;
	Data a259;
	Data a260;
	Data a261;
	Data a262;
	Data a263;
	Data a264;
	Data a265;
	Data a266;
	Data a267;
	Data a268;
	Data a269;
	Data a270;
	Data a271;
	Data a272;
	Data a273;
	Data a274;
	Data a275;
	Data a276;
	Data a277;
	Data a278;
	Data a279;
	Data a280;
	Data a281;
	Data a282;
	Data a283;
	Data a284;
	Data a285;
	Data a286;
	Data a287;
	Data a288;
	Data a289;
};

BigDataContainer::BigDataContainer()
{
}


class BigCopyOnWriteDataContainer
{
    public:
	BigCopyOnWriteDataContainer();
    private:
	CopyOnWriteData a0;
	CopyOnWriteData a1;
	CopyOnWriteData a2;
	CopyOnWriteData a3;
	CopyOnWriteData a4;
	CopyOnWriteData a5;
	CopyOnWriteData a6;
	CopyOnWriteData a7;
	CopyOnWriteData a8;
	CopyOnWriteData a9;
	CopyOnWriteData a10;
	CopyOnWriteData a11;
	CopyOnWriteData a12;
	CopyOnWriteData a13;
	CopyOnWriteData a14;
	CopyOnWriteData a15;
	CopyOnWriteData a16;
	CopyOnWriteData a17;
	CopyOnWriteData a18;
	CopyOnWriteData a19;
	CopyOnWriteData a20;
	CopyOnWriteData a21;
	CopyOnWriteData a22;
	CopyOnWriteData a23;
	CopyOnWriteData a24;
	CopyOnWriteData a25;
	CopyOnWriteData a26;
	CopyOnWriteData a27;
	CopyOnWriteData a28;
	CopyOnWriteData a29;
	CopyOnWriteData a30;
	CopyOnWriteData a31;
	CopyOnWriteData a32;
	CopyOnWriteData a33;
	CopyOnWriteData a34;
	CopyOnWriteData a35;
	CopyOnWriteData a36;
	CopyOnWriteData a37;
	CopyOnWriteData a38;
	CopyOnWriteData a39;
	CopyOnWriteData a40;
	CopyOnWriteData a41;
	CopyOnWriteData a42;
	CopyOnWriteData a43;
	CopyOnWriteData a44;
	CopyOnWriteData a45;
	CopyOnWriteData a46;
	CopyOnWriteData a47;
	CopyOnWriteData a48;
	CopyOnWriteData a49;
	CopyOnWriteData a50;
	CopyOnWriteData a51;
	CopyOnWriteData a52;
	CopyOnWriteData a53;
	CopyOnWriteData a54;
	CopyOnWriteData a55;
	CopyOnWriteData a56;
	CopyOnWriteData a57;
	CopyOnWriteData a58;
	CopyOnWriteData a59;
	CopyOnWriteData a60;
	CopyOnWriteData a61;
	CopyOnWriteData a62;
	CopyOnWriteData a63;
	CopyOnWriteData a64;
	CopyOnWriteData a65;
	CopyOnWriteData a66;
	CopyOnWriteData a67;
	CopyOnWriteData a68;
	CopyOnWriteData a69;
	CopyOnWriteData a70;
	CopyOnWriteData a71;
	CopyOnWriteData a72;
	CopyOnWriteData a73;
	CopyOnWriteData a74;
	CopyOnWriteData a75;
	CopyOnWriteData a76;
	CopyOnWriteData a77;
	CopyOnWriteData a78;
	CopyOnWriteData a79;
	CopyOnWriteData a80;
	CopyOnWriteData a81;
	CopyOnWriteData a82;
	CopyOnWriteData a83;
	CopyOnWriteData a84;
	CopyOnWriteData a85;
	CopyOnWriteData a86;
	CopyOnWriteData a87;
	CopyOnWriteData a88;
	CopyOnWriteData a89;
	CopyOnWriteData a90;
	CopyOnWriteData a91;
	CopyOnWriteData a92;
	CopyOnWriteData a93;
	CopyOnWriteData a94;
	CopyOnWriteData a95;
	CopyOnWriteData a96;
	CopyOnWriteData a97;
	CopyOnWriteData a98;
	CopyOnWriteData a99;
	CopyOnWriteData a100;
	CopyOnWriteData a101;
	CopyOnWriteData a102;
	CopyOnWriteData a103;
	CopyOnWriteData a104;
	CopyOnWriteData a105;
	CopyOnWriteData a106;
	CopyOnWriteData a107;
	CopyOnWriteData a108;
	CopyOnWriteData a109;
	CopyOnWriteData a110;
	CopyOnWriteData a111;
	CopyOnWriteData a112;
	CopyOnWriteData a113;
	CopyOnWriteData a114;
	CopyOnWriteData a115;
	CopyOnWriteData a116;
	CopyOnWriteData a117;
	CopyOnWriteData a118;
	CopyOnWriteData a119;
	CopyOnWriteData a120;
	CopyOnWriteData a121;
	CopyOnWriteData a122;
	CopyOnWriteData a123;
	CopyOnWriteData a124;
	CopyOnWriteData a125;
	CopyOnWriteData a126;
	CopyOnWriteData a127;
	CopyOnWriteData a128;
	CopyOnWriteData a129;
	CopyOnWriteData a130;
	CopyOnWriteData a131;
	CopyOnWriteData a132;
	CopyOnWriteData a133;
	CopyOnWriteData a134;
	CopyOnWriteData a135;
	CopyOnWriteData a136;
	CopyOnWriteData a137;
	CopyOnWriteData a138;
	CopyOnWriteData a139;
	CopyOnWriteData a140;
	CopyOnWriteData a141;
	CopyOnWriteData a142;
	CopyOnWriteData a143;
	CopyOnWriteData a144;
	CopyOnWriteData a145;
	CopyOnWriteData a146;
	CopyOnWriteData a147;
	CopyOnWriteData a148;
	CopyOnWriteData a149;
	CopyOnWriteData a150;
	CopyOnWriteData a151;
	CopyOnWriteData a152;
	CopyOnWriteData a153;
	CopyOnWriteData a154;
	CopyOnWriteData a155;
	CopyOnWriteData a156;
	CopyOnWriteData a157;
	CopyOnWriteData a158;
	CopyOnWriteData a159;
	CopyOnWriteData a160;
	CopyOnWriteData a161;
	CopyOnWriteData a162;
	CopyOnWriteData a163;
	CopyOnWriteData a164;
	CopyOnWriteData a165;
	CopyOnWriteData a166;
	CopyOnWriteData a167;
	CopyOnWriteData a168;
	CopyOnWriteData a169;
	CopyOnWriteData a170;
	CopyOnWriteData a171;
	CopyOnWriteData a172;
	CopyOnWriteData a173;
	CopyOnWriteData a174;
	CopyOnWriteData a175;
	CopyOnWriteData a176;
	CopyOnWriteData a177;
	CopyOnWriteData a178;
	CopyOnWriteData a179;
	CopyOnWriteData a180;
	CopyOnWriteData a181;
	CopyOnWriteData a182;
	CopyOnWriteData a183;
	CopyOnWriteData a184;
	CopyOnWriteData a185;
	CopyOnWriteData a186;
	CopyOnWriteData a187;
	CopyOnWriteData a188;
	CopyOnWriteData a189;
	CopyOnWriteData a190;
	CopyOnWriteData a191;
	CopyOnWriteData a192;
	CopyOnWriteData a193;
	CopyOnWriteData a194;
	CopyOnWriteData a195;
	CopyOnWriteData a196;
	CopyOnWriteData a197;
	CopyOnWriteData a198;
	CopyOnWriteData a199;
	CopyOnWriteData a200;
	CopyOnWriteData a201;
	CopyOnWriteData a202;
	CopyOnWriteData a203;
	CopyOnWriteData a204;
	CopyOnWriteData a205;
	CopyOnWriteData a206;
	CopyOnWriteData a207;
	CopyOnWriteData a208;
	CopyOnWriteData a209;
	CopyOnWriteData a210;
	CopyOnWriteData a211;
	CopyOnWriteData a212;
	CopyOnWriteData a213;
	CopyOnWriteData a214;
	CopyOnWriteData a215;
	CopyOnWriteData a216;
	CopyOnWriteData a217;
	CopyOnWriteData a218;
	CopyOnWriteData a219;
	CopyOnWriteData a220;
	CopyOnWriteData a221;
	CopyOnWriteData a222;
	CopyOnWriteData a223;
	CopyOnWriteData a224;
	CopyOnWriteData a225;
	CopyOnWriteData a226;
	CopyOnWriteData a227;
	CopyOnWriteData a228;
	CopyOnWriteData a229;
	CopyOnWriteData a230;
	CopyOnWriteData a231;
	CopyOnWriteData a232;
	CopyOnWriteData a233;
	CopyOnWriteData a234;
	CopyOnWriteData a235;
	CopyOnWriteData a236;
	CopyOnWriteData a237;
	CopyOnWriteData a238;
	CopyOnWriteData a239;
	CopyOnWriteData a240;
	CopyOnWriteData a241;
	CopyOnWriteData a242;
	CopyOnWriteData a243;
	CopyOnWriteData a244;
	CopyOnWriteData a245;
	CopyOnWriteData a246;
	CopyOnWriteData a247;
	CopyOnWriteData a248;
	CopyOnWriteData a249;
	CopyOnWriteData a250;
	CopyOnWriteData a251;
	CopyOnWriteData a252;
	CopyOnWriteData a253;
	CopyOnWriteData a254;
	CopyOnWriteData a255;
	CopyOnWriteData a256;
	CopyOnWriteData a257;
	CopyOnWriteData a258;
	CopyOnWriteData a259;
	CopyOnWriteData a260;
	CopyOnWriteData a261;
	CopyOnWriteData a262;
	CopyOnWriteData a263;
	CopyOnWriteData a264;
	CopyOnWriteData a265;
	CopyOnWriteData a266;
	CopyOnWriteData a267;
	CopyOnWriteData a268;
	CopyOnWriteData a269;
	CopyOnWriteData a270;
	CopyOnWriteData a271;
	CopyOnWriteData a272;
	CopyOnWriteData a273;
	CopyOnWriteData a274;
	CopyOnWriteData a275;
	CopyOnWriteData a276;
	CopyOnWriteData a277;
	CopyOnWriteData a278;
	CopyOnWriteData a279;
	CopyOnWriteData a280;
	CopyOnWriteData a281;
	CopyOnWriteData a282;
	CopyOnWriteData a283;
	CopyOnWriteData a284;
	CopyOnWriteData a285;
	CopyOnWriteData a286;
	CopyOnWriteData a287;
	CopyOnWriteData a288;
	CopyOnWriteData a289;

};


BigCopyOnWriteDataContainer::BigCopyOnWriteDataContainer()
{
}


class EmptyContainer
{
    public:
	EmptyContainer();
    private:
	int a;
};


EmptyContainer::EmptyContainer()
{
}


void code()
{
    PerfDuration stat(Data("BigDataContainer"));

    stat.start();
    for (int i = 0; i < 1000; i++)
    {
	BigDataContainer* container = new BigDataContainer;
	delete container;
    }
    stat.stop();
    stat.record();

}



void code3()
{
    PerfDuration stat(Data("BigCopyOnWriteDataContainer"));

    stat.start();
    for (int i = 0; i < 1000; i++)
    {
	BigCopyOnWriteDataContainer* container = new BigCopyOnWriteDataContainer;
	delete container;
    }
    stat.stop();
    stat.record();

}



void code2()
{
    PerfDuration stat(Data("EmptyContainer"));

    stat.start();
    for (int i = 0; i < 1000; i++)
    {
	EmptyContainer* container = new EmptyContainer;
	delete container;
    }
    stat.stop();
    stat.record();
}


int main()
{
    code();
    code2();
    code3();

    PerformanceDb& db = PerformanceDb::instance();
    cout << db << endl;

    return 0;
}
